/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUPLIN                                                      */
/* Tabela : PEDILINPPROP                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 19/06/2006 - Eduardo H. c. Ramos                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUPLIN
BEFORE INSERT OR UPDATE OR DELETE
ON PEDILINPPROP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPLIN := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NRPROPOSFAS,0 ) <> NVL(:NEW.NRPROPOSFAS,0)) OR
         (NVL(:OLD.NRVERPROPFAS,0) <> NVL(:NEW.NRVERPROPFAS,0)) OR
         (NVL(:OLD.NRLINPPEDP,0  ) <> NVL(:NEW.NRLINPPEDP,0)) THEN
         :NEW.DTULTATUPLIN := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PEDILINPPROP', '', 'NRPROPOSFAS='||:OLD.NRPROPOSFAS||';NRVERPROPFAS='||:OLD.NRVERPROPFAS||';NRLINPPEDP='||:OLD.NRLINPPEDP||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PEDILINPPROP MODIFY DTULTATUPLIN DEFAULT SYSDATE
/