/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOITTRAB                                               */
/* Tabela : TIPOITTRAB                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2007 - Rejane P. Leite                                               */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE TRIGGER DTULTATU_TIPOITTRAB
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOITTRAB FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPIT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOITTRAB,0 )   <> NVL(:NEW.CDTIPOITTRAB,0)) OR
         (NVL(:OLD.DSTIPOITTRAB,0 )   <> NVL(:NEW.DSTIPOITTRAB,0)) OR
         (NVL(:OLD.DSDIRRAIZARQ,0 )   <> NVL(:NEW.DSTIPOITTRAB,0)) THEN
         :NEW.DTULTATUTPIT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOITTRAB', '','CDTIPOITTRAB='||:OLD.CDTIPOITTRAB||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOITTRAB MODIFY DTULTATUTPIT DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOITTRAB','5.03.010'); END;
/

