/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8430_SUPSTPO.sql

Descrio:
Calcula aos demais perodos e calcula a variao entre cada perodo.

Criao:
05/06/2000 Yoris L. de Souza
*/

CREATE OR REPLACE PROCEDURE EVOLUCAO_PRECOS
                     (P_NREVOLPRECO IN TRABEVOLPREC.NREVOLPRECO%TYPE,
                      P_DTINI       IN TRABEVOLPREC.DTINIPEREVOL%TYPE,
                      P_DTFIN       IN TRABEVOLPREC.DTFINPEREVOL%TYPE,
                      P_NRPERI      IN NUMBER,
                      P_CDPRODUTO   IN TRABEVOLPREC.CDPRODUTO%TYPE DEFAULT NULL)
IS
 V_NRCONTA      NUMBER;
 V_NRPERIODOS   NUMBER;
 V_CDPRODUTO    TRABEVOLPREC.CDPRODUTO%TYPE;
 V_CDPRODUTOANT TRABEVOLPREC.CDPRODUTO%TYPE;
 V_DTINIPEREVOL TRABEVOLPREC.DTINIPEREVOL%TYPE;
 V_VRPRECOEVOL  TRABEVOLPREC.VRPRECOEVOL%TYPE;
 V_VRPERCEVOL   TRABEVOLPREC.VRPERCEVOL%TYPE;
 V_VRPRECAUX    TRABEVOLPREC.VRPRECOEVOL%TYPE;
 V_TCDPRODUTO   VARCHAR2(01);

-- CURSOR COM OS PERIODOS DE ACORDO COM A PERIODICIDADE E NUMERO
-- DE PERIODOS
CURSOR C_DATAS IS
SELECT
 CASE P_NRPERI
    WHEN 30
    THEN TO_DATE('01/'||TO_CHAR(P_DTINI, 'MM/YYYY'), 'DD/MM/YYYY')
    ELSE TO_DATE(P_DTINI)
 END DATAINI,
 CASE P_NRPERI
    WHEN 30
    THEN LAST_DAY(P_DTINI)
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 1) - 1
 END DATAFIN
FROM
 PARAMGERAL
WHERE
 1 <= V_NRPERIODOS
UNION
SELECT
 CASE P_NRPERI
    WHEN 30
    THEN TO_DATE('01/'||TO_CHAR(ADD_MONTHS(P_DTINI, 1), 'MM/YYYY'), 'DD/MM/YYYY')
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 1)
 END DATAINI,
 CASE P_NRPERI
    WHEN 30
    THEN LAST_DAY(ADD_MONTHS(P_DTINI, 1))
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 2) - 1
 END DATAFIN
FROM
 PARAMGERAL
WHERE
 2 <= V_NRPERIODOS
UNION
SELECT
 CASE P_NRPERI
    WHEN 30
    THEN TO_DATE('01/'||TO_CHAR(ADD_MONTHS(P_DTINI, 2), 'MM/YYYY'), 'DD/MM/YYYY')
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 2)
 END DATAINI,
 CASE P_NRPERI
    WHEN 30
    THEN LAST_DAY(ADD_MONTHS(P_DTINI, 2))
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 3) - 1
 END DATAFIN
FROM
 PARAMGERAL
WHERE
 3 <= V_NRPERIODOS
UNION
SELECT
 CASE P_NRPERI
    WHEN 30
    THEN TO_DATE('01/'||TO_CHAR(ADD_MONTHS(P_DTINI, 3), 'MM/YYYY'), 'DD/MM/YYYY')
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 3)
 END DATAINI,
 CASE P_NRPERI
    WHEN 30
    THEN LAST_DAY(ADD_MONTHS(P_DTINI, 3))
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 4) - 1
 END DATAFIN
FROM
 PARAMGERAL
WHERE
 4 <= V_NRPERIODOS
UNION
SELECT
 CASE P_NRPERI
    WHEN 30
    THEN TO_DATE('01/'||TO_CHAR(ADD_MONTHS(P_DTINI, 4), 'MM/YYYY'), 'DD/MM/YYYY')
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 4)
 END DATAINI,
 CASE P_NRPERI
    WHEN 30
    THEN LAST_DAY(ADD_MONTHS(P_DTINI, 4))
    ELSE TO_DATE(P_DTINI) + (P_NRPERI * 5) - 1
 END DATAFIN
FROM
 PARAMGERAL
WHERE
 5 <= V_NRPERIODOS;

-- CURSOR COM TODOS OS PRODUTOS SELECIONADOS
CURSOR C_PRODUTO IS
 SELECT
  DISTINCT
  CDPRODUTO
 FROM
  TRABEVOLPREC
 WHERE
  NREVOLPRECO = P_NREVOLPRECO AND
  (CDPRODUTO   = P_CDPRODUTO OR V_TCDPRODUTO = 'T');

CURSOR C_TRABEVOL IS
 SELECT
  CDPRODUTO,
  DTINIPEREVOL,
  VRPRECOEVOL
 FROM
  TRABEVOLPREC
 WHERE
  NREVOLPRECO = P_NREVOLPRECO AND
 (CDPRODUTO   = P_CDPRODUTO OR V_TCDPRODUTO = 'T');

BEGIN
-- SE NAO PASSAR O PRODUTO (NULL) SERO PROCESSADOS TODOS OS PRODUTOS
-- SENAO SERA PROCESSADO O PRODUTO PASSADO COMO PARAMETRO
  V_TCDPRODUTO := '';
  IF P_CDPRODUTO IS NULL THEN
     V_TCDPRODUTO := 'T';
  END IF;

-- CALCULA O NUMERO DE PERIODOS PARA SELECAO DAS DATAS
  V_NRPERIODOS := ROUND((P_DTFIN - P_DTINI) / P_NRPERI) + 1;

  FOR C_PROD IN C_PRODUTO LOOP

    FOR C_DAT IN C_DATAS LOOP

      SELECT
       COUNT(*) INTO V_NRCONTA
      FROM
       TRABEVOLPREC TRAB
      WHERE
       TRAB.NREVOLPRECO  = P_NREVOLPRECO    AND
       TRAB.CDPRODUTO    = C_PROD.CDPRODUTO AND
       TRAB.DTINIPEREVOL = C_DAT.DATAINI;

      IF V_NRCONTA = 0 THEN -- SE NAO ENCONTROU O REGISTRO DA PRODUTOS NA DATA
         INSERT INTO TRABEVOLPREC
           (NREVOLPRECO,CDPRODUTO,DTINIPEREVOL,DTFINPEREVOL,
            VRPRECOEVOL, VRPERCEVOL)
           VALUES
           (P_NREVOLPRECO,C_PROD.CDPRODUTO,C_DAT.DATAINI,C_DAT.DATAFIN,
            0,0);
      END IF;
    END LOOP; 
  END LOOP;

  -- CALCULA A VARIACAO EM CADA PERIODO
  -- ((Preco do periodo atual / Preco do periodo anterior) - 1) * 100
  OPEN C_TRABEVOL;
  FETCH C_TRABEVOL
  INTO V_CDPRODUTO,
       V_DTINIPEREVOL,
       V_VRPRECAUX;
  V_CDPRODUTOANT := V_CDPRODUTO;
  LOOP
    FETCH C_TRABEVOL
    INTO V_CDPRODUTO,
         V_DTINIPEREVOL,
         V_VRPRECOEVOL;
    EXIT WHEN C_TRABEVOL%NOTFOUND;

    IF V_CDPRODUTOANT = V_CDPRODUTO THEN
       IF V_VRPRECAUX = 0 AND V_VRPRECOEVOL = 0 THEN
          V_VRPERCEVOL := 0;
       ELSE
          IF V_VRPRECAUX = 0 THEN
             V_VRPERCEVOL := 100;
          ELSE
             IF V_VRPRECOEVOL = 0 THEN
                V_VRPERCEVOL := 0;
             ELSE
                V_VRPERCEVOL := ((V_VRPRECOEVOL / V_VRPRECAUX) - 1) * 100;
             END IF;
          END IF;
       END IF;
       IF V_VRPRECOEVOL = 0 THEN
          V_VRPRECOEVOL := V_VRPRECAUX;
       END IF;
    ELSE
       V_VRPERCEVOL   := NULL;
       V_CDPRODUTOANT := V_CDPRODUTO;
       V_VRPRECAUX    := 0;
    END IF;

    UPDATE TRABEVOLPREC
    SET VRPERCEVOL  = V_VRPERCEVOL,
        VRPRECOEVOL = V_VRPRECOEVOL
    WHERE
     NREVOLPRECO  = P_NREVOLPRECO AND
     CDPRODUTO    = V_CDPRODUTO   AND
     DTINIPEREVOL = V_DTINIPEREVOL;

    IF V_VRPRECOEVOL <> 0 THEN
       V_VRPRECAUX := V_VRPRECOEVOL;
    END IF;

  END LOOP;
  CLOSE C_TRABEVOL;

  DELETE TRABEVOLPREC
   WHERE (NREVOLPRECO = P_NREVOLPRECO)
     AND (CDPRODUTO   = P_CDPRODUTO OR V_TCDPRODUTO = 'T')
     AND (DTINIPEREVOL < CASE P_NRPERI
                            WHEN 30
                            THEN ADD_MONTHS((LAST_DAY(P_DTINI)+1), -1)
                            ELSE P_DTINI
                         END OR DTINIPEREVOL > P_DTFIN);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EVOLUCAO_PRECOS','6.00.XXX'); END;
/

